// -*- coding: iso-8859-1-unix -*-

#include "stubs/hello.h"
#include "stubs/scs.h"

#include <fstream>
#include <string>

int main(int argc, char *argv[])
{
  try
  {
    CORBA::ORB_var orb(CORBA::ORB_init(argc, argv));
    std::string ior;
    std::ifstream fior(".ior");
    if (!fior)
    {
      std::cerr << "Arquivo '.ior' no localizado." << std::endl;
      return 1;
    }
    fior >> ior;

    CORBA::Object_var o(orb->string_to_object(ior.c_str()));
    scs::core::IComponent_var icomponent(scs::core::IComponent::_narrow(o));
    assert(CORBA::is_nil(icomponent) == false);

    o = icomponent->getFacet("IDL:scs::demos::hello::IHello:1.0");

    scs::demos::hello::IHello_var facet(scs::demos::hello::IHello::_narrow(o));
    assert(CORBA::is_nil(facet) == false);

    icomponent->startup();
    facet->sayHello();
  }
  catch (const CORBA::SystemException &e)
  {
    //Mico does not implement CORBA::Exception_rep_id()
    std::cerr << "CORBA::SystemException with "
              << "rep_id:" << e._repoid() 
              << " and minor:" << e.minor() << std::endl;
    return 1;
  }
	return 0; //MSVC v9
}
