// -*- coding: iso-8859-1-unix -*-

#include "stubs/hello.h"

#include <CORBA.h>
#include <scs/ComponentContext.hpp>
#include <iostream>
#include <fstream>
#include <string>

struct hello_impl : public POA_scs::demos::hello::IHello
{
  void sayHello()
  {
    std::cout << "Hello!" << std::endl;
  }
};

int main(int argc, char *argv[])
{
  try
  {
    CORBA::ORB_var orb(CORBA::ORB_init(argc, argv));
    CORBA::Object_var o(orb->resolve_initial_references("RootPOA"));
    PortableServer::POA_var poa(PortableServer::POA::_narrow(o));
    PortableServer::POAManager_var poa_manager(poa->the_POAManager());
    poa_manager->activate();

    // std::list<scs::core::ExtendedFacetDescription> extFacets;
    // scs::core::ExtendedFacetDescription helloDesc;
    // helloDesc.name = "IHello";
    // helloDesc.interface_name = "IDL:scs::demos::hello::IHello:1.0";

    scs::core::ComponentId componentId;
    componentId.name = "HelloComponent";
    componentId.major_version = '1';
    componentId.minor_version = '0';
    componentId.patch_version = '0';
    componentId.platform_spec = "none";

    scs::core::ComponentContext context(orb, poa, componentId);

    std::auto_ptr<PortableServer::ServantBase> facet(new hello_impl);
    context.addFacet("IHello", "IDL:scs::demos::hello::IHello:1.0", facet);

    o = context.getFacetByName("IComponent").reference;
    scs::core::IComponent_var icomponent(scs::core::IComponent::_narrow(o));
    {
      std::string sior(orb->object_to_string(icomponent));
      std::ofstream ior(".ior");
      ior << sior;
    }
    orb->run();
  }
  catch (const CORBA::SystemException &e)
  {
    //Mico does not implement CORBA::Exception_rep_id()
    std::cerr << "CORBA::SystemException with "
              << "rep_id:" << e._repoid() 
              << " and minor:" << e.minor() << std::endl;
    return 1;
  }
	return 0; //MSVC v9
}
