// -*- coding: iso-8859-1-unix -*-

#ifndef TECGRAF_SCS_RECEPTACLE_HPP
#define TECGRAF_SCS_RECEPTACLE_HPP

#include <scs/private/config.hpp>
#include <stubs/scs.h>

#include <CORBA.h>
#include <list>
#include <map>
#include <string>

namespace scs {
  namespace core {
    /*
     * Classe criada para facilitar o gerenciamento dos receptaculos no servant da
     * interface IReceptacles.
     */
    struct Receptacle
    {
      std::string name, interface_name;
      bool multiplexed;
      std::map<ConnectionId, CORBA::Object_var> connections;

      Receptacle(std::string name, std::string interface_name
                 , bool multiplexed)
        : name(name), interface_name(interface_name)
        , multiplexed(multiplexed) {}
    };
  }
}
#endif // RECEPTACLE_H
