// -*- coding: iso-8859-1-unix -*-

/*
** IComponent.cpp
*/

#include <scs/IComponent.hpp>
#include <scs/ComponentContext.hpp>

#include <cstdlib>

namespace scs {
  namespace core {
    IComponentImpl::IComponentImpl(ComponentContext& component)
      : component(&component)
    {
    }

    IComponentImpl::~IComponentImpl()
    {
    }

    void IComponentImpl::startup() 
    {}

    void IComponentImpl::shutdown() 
    {
    }

    CORBA::Object_ptr IComponentImpl::getFacet(const char* facet_interface) 
    {
#ifdef SCS_THREADING_ENABLED
      ComponentContext::facet_lock lock(*component);
#endif
      std::map<std::string, CORBA::Object_var>
        ::const_iterator iterator = component->getMapFacets().find(facet_interface);
      if(iterator != component->getMapFacets().end())
      {
        CORBA::Object_var o = iterator->second;
        assert(!CORBA::is_nil(o));
        return o._retn();
      }
      else
        return CORBA::Object::_nil();
    }


    CORBA::Object_ptr IComponentImpl::getFacetByName(const char* facet) 
    {
#ifdef SCS_THREADING_ENABLED
      ComponentContext::facet_lock lock(*component);
#endif
      std::map<std::string, Facet>
        ::const_iterator iterator = component->getMapFacetsByName().find(facet);
      if(iterator != component->getMapFacetsByName().end())
      {
        CORBA::Object_var o = iterator->second.reference;
        assert(!CORBA::is_nil(o));
        return o._retn();
      }
      else
        return CORBA::Object::_nil();
    }

    ComponentId* IComponentImpl::getComponentId() 
    {
      ComponentId_var cId = new ComponentId(component->getComponentId());
      return cId._retn();
    }
  }
}

