
#include <scs/ComponentContext.hpp>
#include <hello.h>
#include <typeinfo>

struct HelloServant : POA_scs::test::helloworld::Hello
{
  void sayHello()
  {
  }
};

int main(int argc, char** argv)
{
  CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "");
  
  CORBA::Object_var poa_obj = orb->resolve_initial_references("RootPOA");
  if(!CORBA::is_nil(poa_obj))
  {
    PortableServer::POA_var poa = PortableServer::POA::_narrow(poa_obj);
    PortableServer::POAManager_var mgr = poa->the_POAManager();
    mgr->activate();
    scs::core::ComponentId component_id = {"MyComponent", 1, 0, 0, ""};

    scs::core::ComponentContext context(orb, poa, component_id);
    context.addReceptacle("HelloReceptacle", "IDL:scs/test/helloworld/Hello:1.0");

    scs::core::IComponent_var component = context.getIComponent();
    assert(!CORBA::is_nil(component));
    
    {
      CORBA::Object_var receptacles_obj = component->getFacet("IDL:scs/core/IReceptacles:1.0");
      assert(!CORBA::is_nil(receptacles_obj));
      scs::core::IReceptacles_var receptacles_facet = scs::core::IReceptacles::_narrow(receptacles_obj);
      assert(!CORBA::is_nil(receptacles_facet));

      HelloServant hello_servant;

      CORBA::Object_var object = hello_servant._this();
        
      scs::core::ConnectionId id = receptacles_facet->connect("HelloReceptacle", object);
      scs::core::ConnectionDescriptions_var connections
        = receptacles_facet->getConnections("HelloReceptacle");
      assert(connections->length() == 1);
      assert((*connections)[0].id == id);
      assert(!CORBA::is_nil((*connections)[0].objref));

      receptacles_facet->disconnect(id);
    }
  }
  else
    return -1;
}
