
#include <scs/ComponentContext.hpp>

int main(int argc, char** argv)
{
  CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "");
  
  CORBA::Object_var poa_obj = orb->resolve_initial_references("RootPOA");
  if(!CORBA::is_nil(poa_obj))
  {
    PortableServer::POA_var poa = PortableServer::POA::_narrow(poa_obj);
    PortableServer::POAManager_var mgr = poa->the_POAManager();
    mgr->activate();
    scs::core::ComponentId component_id = {"MyComponent", 1, 0, 0, ""};

    scs::core::ComponentContext context(orb, poa, component_id);
    scs::core::IComponent_var component = context.getIComponent();
    assert(!CORBA::is_nil(component));
    
    {
      CORBA::Object_var component_obj = component->getFacet("IDL:scs/core/IComponent:1.0");
      assert(!CORBA::is_nil(component_obj));
      scs::core::IComponent_var component_facet = scs::core::IComponent::_narrow(component_obj);
      assert(!CORBA::is_nil(component_facet));
    }
  }
  else
    return -1;
}
